/**
 *
 * @file
 * Copyright &copy; Audi Electronics Venture GmbH. All rights reserved
 *
 */
#ifndef _PACKAGE_DDL_HEADER_
#define _PACKAGE_DDL_HEADER_

#include <a_utils.h>
#include <stack>
// OO-DDL interfaces
#include "ddlrepresentation/pkg_ddlrepresentation.h"
#include "codec/pkg_codec.h"
#include "serialization/pkg_serialization.h"
#ifdef DDL_ENABLE_DEPRECATED_CODER
    #include "ddlcoder/pkg_ddlcoder.h"
#endif

#ifndef PKG_DDL_NO_GLOBAL_DDL_NAMESPACE
// this is to prevent name and linker collisions with the open source variant of the ddl package
namespace ddl
{
//we need to declare it this way: 
// Reason 1: using ddl = adtf_ddl; is NOT possible here because another namspace ddl exists (for using new and old package together)!
// Reason 2: using adtf_ddl; is not possible => sub namespaces are ambigous afterwards and can not be used with using namspace ddl; anymore!
// Solution: use the access_element namspace and using statements for all classes in adtf_ddl!
namespace access_element
{
using namespace adtf_ddl::access_element;
}
namespace serialization
{
//we can not use the transform_to_buffer, there is a name clash!
using adtf_ddl::serialization::transform_to_buffer;
}

using cDDLError = adtf_ddl::cDDLError;

using tDDLPropertyVec = adtf_ddl::tDDLPropertyVec;
using cDDLProperty = adtf_ddl::cDDLProperty;
using cDDLDescription = adtf_ddl::cDDLDescription;
using cDDLStreamMetaType = adtf_ddl::cDDLStreamMetaType;
using cDDLCompare = adtf_ddl::cDDLCompare;
using cDDLVersionHelper = adtf_ddl::cDDLVersionHelper;
using tDDLVersion = adtf_ddl::tDDLVersion;
using cDDLCloner = adtf_ddl::cDDLCloner;
using IDDLFactoryMethod = adtf_ddl::IDDLFactoryMethod;
using cDDLByteorder = adtf_ddl::cDDLByteorder;
using cDDL = adtf_ddl::cDDL;
using IDDL = adtf_ddl::IDDL;
using cDDLAlignment = adtf_ddl::cDDLAlignment;
using IDDLUnit = adtf_ddl::IDDLUnit;
using cDDLBaseunit = adtf_ddl::cDDLBaseunit;
using cDDLPrefix = adtf_ddl::cDDLPrefix;
using cDDLRefUnit = adtf_ddl::cDDLRefUnit;
using tDDLRefUnitVec = adtf_ddl::tDDLRefUnitVec;
using tDDLRefUnitIt = adtf_ddl::tDDLRefUnitIt;
using cDDLUnit = adtf_ddl::cDDLUnit;
using cDDLElement = adtf_ddl::cDDLElement;
using tDDLElementVec = adtf_ddl::tDDLElementVec;
using tDDLElementIt = adtf_ddl::tDDLElementIt;
using cDDLComplex = adtf_ddl::cDDLComplex;
using IDDLDataType = adtf_ddl::IDDLDataType;
using cDDLDataType = adtf_ddl::cDDLDataType;
using cDDLEnum = adtf_ddl::cDDLEnum;
using tEnumNameValueVec = adtf_ddl::tEnumNameValueVec;
using cDDLExtDeclaration = adtf_ddl::cDDLExtDeclaration;
using cDDLExtDeclaration = adtf_ddl::cDDLExtDeclaration;
using tDDLExtDeclarationVec = adtf_ddl::tDDLExtDeclarationVec;
using tDDLExtDeclarationIt = adtf_ddl::tDDLExtDeclarationIt;
using cDDLHeader = adtf_ddl::tDDLExtDeclarationIt;
using tImporterMsgSeverity = adtf_ddl::tImporterMsgSeverity;
using tImporterMsg = adtf_ddl::tImporterMsg;
using tImporterMsgList = adtf_ddl::tImporterMsgList;
using cDDLImporter = adtf_ddl::cDDLImporter;
using cDDLInspector = adtf_ddl::cDDLInspector;
using IDDLVisitor = adtf_ddl::IDDLVisitor;
using cDDLRepair = adtf_ddl::cDDLRepair;
using cDDLResolver = adtf_ddl::cDDLResolver;
using cDDLStreamStruct = adtf_ddl::cDDLStreamStruct;
using tDDLStreamStructVec = adtf_ddl::tDDLStreamStructVec;
using tDDLStreamStructIt = adtf_ddl::tDDLStreamStructIt;
using cDDLStream = adtf_ddl::cDDLStream;
using cDDLStreamMetaType = adtf_ddl::cDDLStreamMetaType;
using cDDLPrinter = adtf_ddl::cDDLPrinter;
using cElementAccessor = adtf_ddl::cElementAccessor;
using tStructLayoutElement = adtf_ddl::tStructLayoutElement;
using tStructElement = adtf_ddl::tStructElement;
using cCodec = adtf_ddl::cCodec;
using cDecoder = adtf_ddl::cDecoder;
using cStaticDecoder = adtf_ddl::cStaticDecoder;
using cStaticCodec = adtf_ddl::cStaticCodec;
using cCodecFactory = adtf_ddl::cCodecFactory;

} // namespace ddl
#endif

#endif // _ADTF_INTERFACE_PACKAGE_HEADER_
